diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/CHANGELOG olsrd-current/CHANGELOG
--- olsrd-0.5.0/CHANGELOG	2007-04-01 23:44:14.000000000 +0200
+++ olsrd-current/CHANGELOG	2007-04-03 10:25:19.000000000 +0200
@@ -1,5 +1,5 @@
 This file states changes as of version 0.2.4:
-$Id: CHANGELOG,v 1.58 2007/04/01 21:44:14 bernd67 Exp $
+$Id: CHANGELOG,v 1.59 2007/04/03 08:25:19 bernd67 Exp $
 
 0.5.0 ---------------------------------------------------------------------
 
@@ -11,14 +11,9 @@
 removed hardcoded limit on the number of interfaces (at least in the Unix part)
 made Makefile targets much more consistent
 
-BUGFIXES
-all over the place
-
 MISC
 put Bmf-1.3 plugin into it
 
-0.4.11 --------------------------------------------------------------------
-
 FreeBSD IPv6 SUPPORT
 
 Patch from John Hay applied.
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/files/olsrd.conf.default.lq-fisheye olsrd-current/files/olsrd.conf.default.lq-fisheye
--- olsrd-0.5.0/files/olsrd.conf.default.lq-fisheye	2007-02-10 20:27:32.000000000 +0100
+++ olsrd-current/files/olsrd.conf.default.lq-fisheye	2007-04-20 00:28:09.000000000 +0200
@@ -3,7 +3,7 @@
 #
 # Lines starting with a # are discarded
 #
-# This file was shipped with olsrd 0.X.X
+# This file was shipped with olsrd 0.5.0-unoffical
 #
 
 # This file is an example of a typical
@@ -14,7 +14,7 @@
 # Debug level(0-9)
 # If set to 0 the daemon runs in the background
 
-DebugLevel	2
+DebugLevel	0
 
 
 # Fisheye mechanism for TC messages 0=off, 1=on
@@ -22,6 +22,19 @@
 LinkQualityFishEye 1
 
 
+# Don't recalculate the Dijkstra-table for every incoming topology 
+# control packet. There is no need to recalculate the whole table 
+# if a minor change occured several hops away. Small CPUs will start
+# to glow if you do this in a mesh of considerable size. Rather the table 
+# should be recalculated if a change occured in the neighborhood 
+# of this node. The first number is the number of hops. Nodes within 
+# this number of hops trigger a recalculation of the table. If the 
+# number is 0 no incoming topology control packet will trigger 
+# a recalculation of the table. The second number (floating point!) 
+# is the length ot the interval until the table is recalculated anyway.    
+
+LinkQualityDijkstraLimit 1 6.0
+
 
 # IP version to use (4 or 6)
 
@@ -141,10 +154,6 @@
 
 Pollrate	0.05
 
-# Interval to poll network interfaces for configuration 
-# changes. Defaults to 2.5 seconds
-
-NicChgsPollInt  3.0
 
 # TC redundancy
 # Specifies how much neighbor info should
@@ -204,6 +213,14 @@
 #   PlParam     "Ping"       "194.25.2.129"
 #}
 
+LoadPlugin "olsrd_httpinfo.so.0.1"
+{
+    PlParam     "port"   "8080"
+    PlParam     "Host"   "127.0.0.1"
+#    PlParam     "Host"   "80.23.53.22"
+#    PlParam     "Net"    "10.0.0.0 255.0.0.0"
+#    PlParam     "Net"    "192.168.0.0 255.255.0.0"
+}
 
 
 # Interfaces and their rules
@@ -215,18 +232,10 @@
 # !!CHANGE THE INTERFACE LABEL(s) TO MATCH YOUR INTERFACE(s)!!
 # (eg. wlan0 or eth1):
 
-Interface "XXX" "YYY"
-{
+#Interface "eth0" "eth1" "eth2" "wlan0" "ath0" "rausb0"
 
-    # Olsrd can autodetect changes in NIC
-    # configurations(IP address changes etc.). 
-    # This is Enabled by default and the interval
-    # to poll for changes on is defined by 
-    # NicChgsPollInt.
-    # This polling can be disabled pr. NIC by setting
-    # AutoDetectChanges to no.
-
-    # AutoDetectChanges            yes
+Interface "rausb0"
+{
 
     # IPv4 broadcast address to use. The
     # one usefull example would be 255.255.255.255
@@ -263,8 +272,12 @@
     # HELLO validity time
     HelloValidityTime	200.0
 
-    # TC interval in seconds(float)
-    TcInterval        0.5
+
+    # TC interval in seconds(float) 0.5 is only viable when
+    # LinkQualityFishEye is enabled. Otherwise larger networks would
+    # suffocate from a massive protocol overhead of TC-messages
+
+    TcInterval        2.5
 
     # TC validity time
     TcValidityTime	250.0
@@ -273,7 +286,7 @@
     MidInterval	5.0
 
     # MID validity time
-    MidValidityTime	100.0
+    MidValidityTime	300.0
 
     # HNA interval in seconds(float)
     HnaInterval	5.0
@@ -282,31 +295,13 @@
     HnaValidityTime 	100.0
 
 
-    # When multiple links exist between hosts
-    # the weight of interface is used to determine
-    # the link to use. Normally the weight is
-    # automatically calculated by olsrd based
-    # on the characteristics of the interface,
-    # but here you can specify a fixed value.
-    # Olsrd will choose links with the lowest value.
-    # Note:
-    # Interface weight is used only when LinkQualityLevel is set to 0.
-    # For any other value of LinkQualityLevel, the interface ETX
-    # value is used instead.
-    # Weight 0
-
-
-    # If a certain route should be preferred 
-    # or ignored by the mesh, the Link Quality 
-    # value of a node can be multiplied with a factor 
-    # entered here. In the example the route 
-    # using 192.168.0.1 would rather be ignored.
-    # A multiplier of 0.5 will result in a small
-    # (bad) LinkQuality value and a high (bad)
-    # ETX value.
-    # Note:
-    # Link quality multiplier is used only when
-    # LinkQualityLevel is > 0.
+
+    # If a certain route should be preferred or ignored by the mesh, the
+    # Link Quality value of a node can be multiplied with a factor entered
+    # here. In the example the route using 192.168.0.1 would rather be
+    # ignored.  A multiplier of 0.5 will result in a small (bad) LinkQuality
+    # value and a high (bad) ETX value.  Note: Link quality multiplier is
+    # used only when LinkQualityLevel is > 0.
 
     # LinkQualityMult 192.168.0.1 0.5
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/gcc-warnings olsrd-current/gcc-warnings
--- olsrd-0.5.0/gcc-warnings	1970-01-01 01:00:00.000000000 +0100
+++ olsrd-current/gcc-warnings	2007-05-01 23:36:50.000000000 +0200
@@ -0,0 +1,32 @@
+#!/bin/bash --norc
+#
+# We expect warning options for gcc as argumenst and return the ones which are accepted
+# by the given gcc.
+#
+# $Id: gcc-warnings,v 1.1 2007/05/01 21:36:50 bernd67 Exp $
+
+set -ue
+#set -vx
+
+OPTS=""
+for param; do
+    case "$param" in
+    -W?*) OPTS="$OPTS $param";;
+    *)    echo "Ignoring $param" >&2
+    esac
+done
+
+while read error; do 
+    case "$error" in
+    *error:\ unrecognized\ option*) opt="${error#*\`}"
+                                    opt="${opt%\'*}"
+                                    OPTS="${OPTS//$opt/}"
+                                    ;;
+    esac
+done < <(cat <<EOF | $CC $OPTS -E - 2>&1 >/dev/null
+    int main(void) {
+        return 0;
+    }
+    EOF)
+echo $OPTS
+exit 0
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/gui/linux-gtk/src/olsr_protocol.h olsrd-current/gui/linux-gtk/src/olsr_protocol.h
--- olsrd-0.5.0/gui/linux-gtk/src/olsr_protocol.h	2004-09-14 18:45:41.000000000 +0200
+++ olsrd-current/gui/linux-gtk/src/olsr_protocol.h	2007-04-22 22:25:48.000000000 +0200
@@ -247,7 +247,7 @@
 };
 
 
-struct tcmsg 
+struct olsr_tcmsg 
 {
   olsr_u16_t        ansn;
   olsr_u16_t        reserved;
@@ -265,7 +265,7 @@
 };
 
 
-struct tcmsg6
+struct olsr_tcmsg6
 {
   olsr_u16_t           ansn;
   olsr_u16_t           reserved;
@@ -366,7 +366,7 @@
   union 
   {
     struct hellomsg hello;
-    struct tcmsg    tc;
+    struct olsr_tcmsg    tc;
     struct hnamsg   hna;
     struct midmsg   mid;
   } message;
@@ -390,7 +390,7 @@
   union 
   {
     struct hellomsg6 hello;
-    struct tcmsg6    tc;
+    struct olsr_tcmsg6    tc;
     struct hnamsg6   hna;
     struct midmsg6   mid;
   } message;
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/gui/linux-gtk/src/packet.h olsrd-current/gui/linux-gtk/src/packet.h
--- olsrd-0.5.0/gui/linux-gtk/src/packet.h	2004-09-19 13:48:20.000000000 +0200
+++ olsrd-current/gui/linux-gtk/src/packet.h	2007-04-22 22:25:48.000000000 +0200
@@ -51,8 +51,8 @@
 
 union tc_message
 {
-  struct tcmsg v4;
-  struct tcmsg6 v6;
+  struct olsr_tcmsg v4;
+  struct olsr_tcmsg6 v6;
 };
 
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/Makefile olsrd-current/lib/bmf/Makefile
--- olsrd-0.5.0/lib/bmf/Makefile	2007-02-10 18:05:55.000000000 +0100
+++ olsrd-current/lib/bmf/Makefile	2007-04-22 19:40:38.000000000 +0200
@@ -31,11 +31,10 @@
 # ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 # POSSIBILITY OF SUCH DAMAGE.
 #
-# $Id: Makefile,v 1.2 2007/02/10 17:05:55 bernd67 Exp $
 
 OLSRD_PLUGIN =	true
 PLUGIN_NAME =	olsrd_bmf
-PLUGIN_VER =	1.3
+PLUGIN_VER =	1.4
 
 TOPDIR = ../..
 include $(TOPDIR)/Makefile.inc
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/Address.c olsrd-current/lib/bmf/src/Address.c
--- olsrd-0.5.0/lib/bmf/src/Address.c	2007-02-10 18:05:55.000000000 +0100
+++ olsrd-current/lib/bmf/src/Address.c	2007-04-22 19:40:38.000000000 +0200
@@ -35,12 +35,12 @@
  * Description: IP packet characterization functions
  * Created    : 29 Jun 2006
  *
- * $Id: Address.c,v 1.2 2007/02/10 17:05:55 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
  
 #include "Address.h"
 
 /* System includes */
+#include <stddef.h> /* NULL */
 #include <assert.h> /* assert() */
 #include <netinet/ip.h> /* struct ip */
 #include <netinet/udp.h> /* struct udphdr */
@@ -99,130 +99,49 @@
 }
 
 /* -------------------------------------------------------------------------
- * Function   : IsLocalBroadcast
- * Description: Check if an IP address is a local broadcast address for a
- *              given network interface
- * Input      : destIp, broadAddr
- * Output     : none
- * Return     : true (1) or false (0)
- * Data Used  : none
- * ------------------------------------------------------------------------- */
-int IsLocalBroadcast(union olsr_ip_addr* destIp, struct sockaddr* broadAddr)
-{
-  struct sockaddr_in* sin;
-  
-  assert(destIp != NULL && broadAddr != NULL);
-
-  /* Cast down to correct sockaddr subtype */
-  sin = (struct sockaddr_in*)broadAddr;
-
-  return COMP_IP(&(sin->sin_addr.s_addr), destIp);
-}
-
-/* -------------------------------------------------------------------------
  * Function   : IsOlsrOrBmfPacket
- * Description: Check if an ethernet packet is an OLSR packet or a BMF packet
- * Input      : intf, ethPkt, len
+ * Description: Check if an IP packet is either an OLSR packet or a BMF packet
+ * Input      : ipPacket
  * Output     : none
  * Return     : true (1) or false (0)
  * Data Used  : none
- * Assumption : len >= IP_HDR_OFFSET + GetIpHeaderLength(ethPkt)
  * ------------------------------------------------------------------------- */
-int IsOlsrOrBmfPacket(struct TBmfInterface* intf, unsigned char* ethPkt, size_t len)
+int IsOlsrOrBmfPacket(unsigned char* ipPacket)
 {
-  struct ip* ipData;
+  struct ip* ipHeader;
   unsigned int ipHeaderLen;
-  struct udphdr* udpData;
+  struct udphdr* udpHeader;
   u_int16_t destPort;
 
-  assert(ethPkt != NULL);
+  assert(ipPacket != NULL);
 
-  /* Consider OLSR and BMF packets not to be local broadcast
-   * OLSR packets are UDP - port 698
+  /* OLSR packets are UDP - port 698
    * OLSR-BMF packets are UDP - port 50698
-   * OLSR-Autodetect probe packets are UDP - port 51698
-   * Fragments of the above packets are also not local broadcast */
+   * OLSR-Autodetect probe packets are UDP - port 51698 */
 
-  ipData = (struct ip*) (ethPkt + IP_HDR_OFFSET);
-  if (ipData->ip_p != SOL_UDP)
+  /* Check if UDP */
+  ipHeader = (struct ip*) ipPacket;
+  if (ipHeader->ip_p != SOL_UDP)
   {
+    /* Not UDP */
     return 0;
   }
 
-  /* Check if the packet is an IP-fragment */
-  if ((ntohs(ipData->ip_off) & IP_OFFMASK) != 0)
-  {
-#if 0
-    int i;
-    for (i = 0; i < FRAGMENT_HISTORY_SIZE; i++)
-    {
-      /* Quick-access pointer */
-      struct TFragmentHistory* entry = &intf->fragmentHistory[i];
-
-      /* Match */
-      if (entry->ipId == ntohs(ipData->ip_id) &&
-          entry->ipProto == ipData->ip_p &&
-          entry->ipSrc.s_addr == ntohl(ipData->ip_src.s_addr) &&
-          entry->ipDst.s_addr == ntohl(ipData->ip_dst.s_addr))
-      {
-        /* Found matching history entry, so packet is assumed to be a fragment
-         * of an earlier OLSR/OLSR-BMF/OLSR-Autodetect packet */
-
-        /* More fragments? If not, invalidate entry */
-        if (((ntohs(ipData->ip_off) & IP_MF) == 0))
-        {
-          memset(entry, 0, sizeof(struct TFragmentHistory));
-        }
-
-        return 1;
-      }
-    }
-
-    /* Matching history entry not found, so packet is not assumed to be a fragment
-     * of an earlier OLSR/OLSR-BMF/OLSR-Autodetect packet */
-#endif
-    /* OOPS! IP-fragments may come in earlier than their main packet. In that case,
-     * their relation with the main packet is not detected by the above code, resulting
-     * in stray fragments being forwarded all ove the network. Solution for now is to
-     * not forward any IP-fragments at all. */
-    /*return 0;*/
-    return 1;
-  }
-
-  /* The packet is the first (or only) IP-fragment */
-
-  /* Check length first */
-  ipHeaderLen = ipData->ip_hl << 2;
-  if (len < IP_HDR_OFFSET + ipHeaderLen + sizeof(struct udphdr))
+  /* The total length must be at least large enough to store the UDP header */
+  ipHeaderLen = GetHeaderLength(ipPacket);
+  if (GetTotalLength(ipPacket) < ipHeaderLen + sizeof(struct udphdr))
   {
+    /* Not long enough */
     return 0;
   }
 
   /* Go into the UDP header and check port number */
-  udpData = (struct udphdr*) (ethPkt + IP_HDR_OFFSET + ipHeaderLen);
-  destPort = ntohs(udpData->dest);
+  udpHeader = (struct udphdr*) (ipPacket + ipHeaderLen);
+  destPort = ntohs(udpHeader->dest);
 
   if (destPort == OLSRPORT || destPort == BMF_ENCAP_PORT || destPort == 51698)
       /* TODO: #define for 51698 */
   {
-#if 0
-    /* If more fragments are expected, keep a record in the fragment history */
-    if ((ntohs(ipData->ip_off) & IP_MF) != 0)
-    {
-      /* Quick-access pointer */
-      struct TFragmentHistory* entry = &intf->fragmentHistory[intf->nextFragmentHistoryEntry];
-
-      /* Store in fragment history */
-      entry->ipId = ntohs(ipData->ip_id);
-      entry->ipProto = ipData->ip_p;
-      entry->ipSrc.s_addr = ntohl(ipData->ip_src.s_addr);
-      entry->ipDst.s_addr = ntohl(ipData->ip_dst.s_addr);
-
-      /* Advance to next entry */
-      intf->nextFragmentHistoryEntry++;
-      intf->nextFragmentHistoryEntry %= FRAGMENT_HISTORY_SIZE;
-    }
-#endif
     return 1;
   }
 
diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/Address.h olsrd-current/lib/bmf/src/Address.h
--- olsrd-0.5.0/lib/bmf/src/Address.h	2007-02-10 18:05:55.000000000 +0100
+++ olsrd-current/lib/bmf/src/Address.h	2007-04-22 19:40:38.000000000 +0200
@@ -38,7 +38,6 @@
  * Description: IP packet characterization functions
  * Created    : 29 Jun 2006
  *
- * $Id: Address.h,v 1.2 2007/02/10 17:05:55 bernd67 Exp $ 
  * ------------------------------------------------------------------------- */
 
 #include "olsr_types.h" /* olsr_ip_addr */
@@ -50,7 +49,6 @@
 
 int DoLocalBroadcast(const char* enable);
 int IsMulticast(union olsr_ip_addr* ipAddress);
-int IsLocalBroadcast(union olsr_ip_addr* destIp, struct sockaddr* broadAddr);
-int IsOlsrOrBmfPacket(struct TBmfInterface* intf, unsigned char* ethPkt, size_t len);
+int IsOlsrOrBmfPacket(unsigned char* ipPacket);
 
 #endif /* _BMF_ADDRESS_H */
